/*
    Programiranje(C) - 2. veljace 2004. [Matko Botincan]
    ----------
    4. zadatak
*/

#include <stdio.h>
#include <string.h>
#include <malloc.h>

typedef struct _cvor {
    char* string;
    struct _cvor* next;
} cvor;

cvor* izbaci(cvor* glava, char* substr) {
    cvor *prethodni, *trenutni;

    while (glava!=NULL && strstr(glava->string, substr)) {
        trenutni=glava;
        glava=glava->next;
        free(trenutni->string);
        free(trenutni);
    }

    if(glava==NULL)
        return glava;

    prethodni=glava;
    trenutni=glava->next;
    while(trenutni!=NULL) {
        if(strstr(trenutni->string, substr)) {
            prethodni->next=trenutni->next;
            free(trenutni->string);
            free(trenutni);
            trenutni=prethodni->next;
        }
        else {
            prethodni=trenutni;
            trenutni=prethodni->next;
        }
    }

    return glava;
}

int main() {
    cvor *glava = NULL, *pomocni;
    char foo[256];
    
    while (1) {
        printf("Unesi string (0 za kraj): ");
        scanf("%s", foo);
        if (!strcmp(foo, "0"))
            break;
        pomocni = (cvor*) malloc(sizeof(cvor));
        pomocni->string = (char*) malloc(sizeof(char)*(strlen(foo)+1));
        strcpy(pomocni->string, foo);
        pomocni->next = glava;
        glava = pomocni;
    }

    printf("Ispis liste: ");
    for(pomocni=glava; pomocni!=NULL; pomocni=pomocni->next)
        printf("%s ", pomocni->string);

    printf("\n\nUnesite podstring: ");
    scanf("%s", foo);
    glava = izbaci(glava, foo);

    printf("Ispis liste: ");
    for(pomocni=glava; pomocni!=NULL; pomocni=pomocni->next)
        printf("%s ", pomocni->string);
    printf("\n");

    while(glava!=NULL) {
        pomocni=glava;
        glava=glava->next;
        free(pomocni->string);
        free(pomocni);
    }

    return 0;
}
